Makefile.am 9.89 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13 14 15 16
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
17
httpdir = $(pkgpythondir)/http
Guido Trotter's avatar
Guido Trotter committed
18
confddir = $(pkgpythondir)/confd
19
rapidir = $(pkgpythondir)/rapi
20 21 22 23 24 25 26 27 28 29
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
	lib \
30
	lib/http \
31
	lib/hypervisor \
32
	lib/rapi \
Guido Trotter's avatar
Guido Trotter committed
33
	lib/confd \
34 35 36 37 38 39 40
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
41
MAINTAINERCLEANFILES = \
42
	$(docpng) \
Iustin Pop's avatar
Iustin Pop committed
43 44
	$(maninput)

45 46 47
maintainer-clean-local:
	-rm -rf doc/api doc/build doc/html

48 49 50
CLEANFILES = \
	autotools/replace_vars.sed \
	devel/upload \
51
	doc/examples/bash_completion \
52 53 54
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
55
	lib/http/*.py[co] \
56
	lib/hypervisor/*.py[co] \
57
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
58 59
	$(man_MANS) \
	$(manhtml) \
60 61 62 63 64 65 66 67 68 69
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
Guido Trotter's avatar
Guido Trotter committed
70
	lib/asyncnotifier.py \
71 72 73 74 75 76 77
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
78
	lib/daemon.py \
79 80
	lib/errors.py \
	lib/jqueue.py \
81
	lib/jstore.py \
82 83 84 85 86 87 88 89 90
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
91
	lib/storage.py \
92 93
	lib/utils.py \
	lib/workerpool.py
94 95 96 97

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
98
	lib/hypervisor/hv_chroot.py \
99
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
100
	lib/hypervisor/hv_kvm.py \
101 102
	lib/hypervisor/hv_xen.py

103 104
rapi_PYTHON = \
	lib/rapi/__init__.py \
105 106 107
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
108

109
http_PYTHON = \
110
	lib/http/__init__.py \
111
	lib/http/auth.py \
112 113
	lib/http/client.py \
	lib/http/server.py
114

Guido Trotter's avatar
Guido Trotter committed
115 116
confd_PYTHON = \
	lib/confd/__init__.py
117

Michael Hanselmann's avatar
Michael Hanselmann committed
118
docrst = \
119
	doc/admin.rst \
120
	doc/design-2.0.rst \
121
	doc/design-2.1.rst \
122
	doc/glossary.rst \
123
	doc/hooks.rst \
124
	doc/iallocator.rst \
125
	doc/index.rst \
126
	doc/install.rst \
127
	doc/rapi.rst \
128
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
129

130 131 132 133 134 135 136 137 138 139
doc/html: $(docrst) $(docpng) doc/conf.py configure.ac
	@test -n "$(SPHINX)" || \
	    { echo 'sphinx-build' not found during configure; exit 1; }
	mkdir -p doc/build/doctrees
	PYTHONPATH=.:$(top_builddir) sphinx-build -q -b html \
	    -d doc/build/doctrees \
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
	    -D release="$(PACKAGE_VERSION)" \
	    $(top_srcdir)/doc doc/html
	touch "$@"
Iustin Pop's avatar
Iustin Pop committed
140

141 142 143
docdot = \
	doc/arch-2.0.dot

144
docpng = $(patsubst %.dot,%.png,$(docdot))
145

146
noinst_DATA = $(manhtml) doc/html
147

148 149 150 151
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
152
	daemons/ganeti-rapi \
153 154 155 156 157 158 159 160 161 162 163 164 165 166 167
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
168
	$(MAINTAINERCLEANFILES) \
169 170
	NEWS \
	DEVNOTES \
Michael Hanselmann's avatar
Michael Hanselmann committed
171
	pylintrc \
172 173
	autotools/docbook-wrapper \
	devel/upload.in \
174
	$(docdot) \
175 176 177
	$(docrst) \
	doc/conf.py \
	doc/html \
178
	doc/examples/bash_completion.in \
179 180 181
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
182
	doc/locking.txt \
183 184 185 186 187
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
188
	$(mansgml) $(maninput) \
189
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
190
	qa/qa-sample.json \
191 192 193 194 195 196 197 198
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
199
	qa/qa_rapi.py \
200 201 202 203 204
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
205
	man/ganeti-masterd.8 \
206 207
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
208
	man/ganeti-rapi.8 \
209 210 211
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
212
	man/gnt-debug.8 \
213
	man/gnt-instance.8 \
214
	man/gnt-job.8 \
215 216 217
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
218 219 220
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
221 222 223

TEST_FILES = \
	test/data/bdev-both.txt \
224
	test/data/bdev-8.3-both.txt \
225 226
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
227 228
	test/data/proc_drbd8.txt \
	test/data/proc_drbd83.txt
229 230

dist_TESTS = \
231 232 233
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
234
	test/ganeti.config_unittest.py \
235
	test/ganeti.constants_unittest.py \
236
	test/ganeti.hooks_unittest.py \
237
	test/ganeti.http_unittest.py \
238
	test/ganeti.locking_unittest.py \
239
	test/ganeti.objects_unittest.py \
240
	test/ganeti.rapi.resources_unittest.py \
241 242 243 244
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
245 246 247 248 249

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

250
TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir) $(PYTHON)
251

252
all-local: stamp-directories lib/_autoconf.py devel/upload \
Iustin Pop's avatar
Iustin Pop committed
253
	doc/examples/bash_completion \
254 255 256 257 258 259
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
260
doc/examples/%: doc/examples/%.in stamp-directories \
261 262 263
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

264
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
265
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
266 267
	$(DOT) -Tpng -o $@ $<

Iustin Pop's avatar
Iustin Pop committed
268
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
269
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
270 271 272 273 274 275 276
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
277
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
278 279 280 281 282 283 284 285
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
286

Iustin Pop's avatar
Iustin Pop committed
287 288
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
289

Iustin Pop's avatar
Iustin Pop committed
290 291
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
292

293 294
man/footer.sgml $(TESTS): srclinks

295
$(TESTS): ganeti lib/_autoconf.py
296 297 298 299 300

lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
301 302 303 304 305 306 307 308 309
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
310 311 312 313 314 315 316 317 318 319 320 321 322 323 324
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
325
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
326
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
327
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
328
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)" ; \
329 330 331 332 333 334 335 336 337 338 339
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
340
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
341 342 343 344 345 346 347
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
#.PHONY: srclinks
srclinks: stamp-directories
	set -e; \
348
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
Guido Trotter's avatar
Guido Trotter committed
349
			$(rapi_PYTHON) $(http_PYTHON) $(confd_PYTHON); do \
350 351 352 353
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
354

Michael Hanselmann's avatar
Michael Hanselmann committed
355 356
.PHONY: ganeti
ganeti:
357
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
358

Iustin Pop's avatar
Iustin Pop committed
359 360 361 362 363 364 365
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
366
install-exec-local:
367
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
368 369
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
370 371 372 373 374

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
375 376 377
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
378
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
379 380
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
381
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
382 383
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
384
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
385 386 387 388
		) ; \
		rm -rf $$TMPDIR ; \
	}

389 390 391 392 393 394 395
.PHONY: TAGS
TAGS:
	rm -f TAGS
	find . -path './lib/*.py' -o -path 'scripts/gnt-*' -o \
	  -path 'daemons/ganeti-*' -o -path 'tools/*' | \
	  etags -

396
# vim: set noet :